module Win32
  module Pdh
    module Constants

      PDH_FMT_LONG = 0x00000100
      PDH_FMT_DOUBLE = 0x00000200
      PDH_FMT_LARGE = 0x00000400
      PDH_FMT_NOSCALE = 0x00001000
      PDH_FMT_1000 = 0x00002000
      PDH_FMT_NOCAP100 = 0x00008000

      PDH_NOEXPANDCOUNTERS = 0x00000001
      PDH_NOEXPANDINSTANCES = 0x00000002

      PDH_CSTATUS_VALID_DATA = 0x00000000
      PDH_CSTATUS_NEW_DATA = 0x00000001
      PDH_CSTATUS_NO_MACHINE = 0x800007D0
      PDH_CSTATUS_NO_INSTANCE = 0x800007D1
      PDH_MORE_DATA = 0x800007D2
      PDH_CSTATUS_ITEM_NOT_VALIDATED = 0x800007D3
      PDH_RETRY = 0x800007D4
      PDH_NO_DATA = 0x800007D5
      PDH_CALC_NEGATIVE_DENOMINATOR = 0x800007D6
      PDH_CALC_NEGATIVE_TIMEBASE = 0x800007D7
      PDH_CALC_NEGATIVE_VALUE = 0x800007D8
      PDH_DIALOG_CANCELLED = 0x800007D9
      PDH_END_OF_LOG_FILE = 0x800007DA
      PDH_ASYNC_QUERY_TIMEOUT = 0x800007DB
      PDH_CANNOT_SET_DEFAULT_REALTIME_DATASOURCE = 0x800007DC
      PDH_CSTATUS_NO_OBJECT = 0xC0000BB8
      PDH_CSTATUS_NO_COUNTER = 0xC0000BB9
      PDH_CSTATUS_INVALID_DATA = 0xC0000BBA
      PDH_MEMORY_ALLOCATION_FAILURE = 0xC0000BBB
      PDH_INVALID_HANDLE = 0xC0000BBC
      PDH_INVALID_ARGUMENT = 0xC0000BBD
      PDH_FUNCTION_NOT_FOUND = 0xC0000BBE
      PDH_CSTATUS_NO_COUNTERNAME = 0xC0000BBF
      PDH_CSTATUS_BAD_COUNTERNAME = 0xC0000BC0
      PDH_INVALID_BUFFER = 0xC0000BC1
      PDH_INSUFFICIENT_BUFFER = 0xC0000BC2
      PDH_CANNOT_CONNECT_MACHINE = 0xC0000BC3
      PDH_INVALID_PATH = 0xC0000BC4
      PDH_INVALID_INSTANCE = 0xC0000BC5
      PDH_INVALID_DATA = 0xC0000BC6
      PDH_NO_DIALOG_DATA = 0xC0000BC7
      PDH_CANNOT_READ_NAME_STRINGS = 0xC0000BC8
      PDH_LOG_FILE_CREATE_ERROR = 0xC0000BC9
      PDH_LOG_FILE_OPEN_ERROR = 0xC0000BCA
      PDH_LOG_TYPE_NOT_FOUND = 0xC0000BCB
      PDH_NO_MORE_DATA = 0xC0000BCC
      PDH_ENTRY_NOT_IN_LOG_FILE = 0xC0000BCD
      PDH_DATA_SOURCE_IS_LOG_FILE = 0xC0000BCE
      PDH_DATA_SOURCE_IS_REAL_TIME = 0xC0000BCF
      PDH_UNABLE_READ_LOG_HEADER = 0xC0000BD0
      PDH_FILE_NOT_FOUND = 0xC0000BD1
      PDH_FILE_ALREADY_EXISTS = 0xC0000BD2
      PDH_NOT_IMPLEMENTED = 0xC0000BD3
      PDH_STRING_NOT_FOUND = 0xC0000BD4
      PDH_UNABLE_MAP_NAME_FILES = 0x80000BD5
      PDH_UNKNOWN_LOG_FORMAT = 0xC0000BD6
      PDH_UNKNOWN_LOGSVC_COMMAND = 0xC0000BD7
      PDH_LOGSVC_QUERY_NOT_FOUND = 0xC0000BD8
      PDH_LOGSVC_NOT_OPENED = 0xC0000BD9
      PDH_WBEM_ERROR = 0xC0000BDA
      PDH_ACCESS_DENIED = 0xC0000BDB
      PDH_LOG_FILE_TOO_SMALL = 0xC0000BDC
      PDH_INVALID_DATASOURCE = 0xC0000BDD
      PDH_INVALID_SQLDB = 0xC0000BDE
      PDH_NO_COUNTERS = 0xC0000BDF
      PDH_SQL_ALLOC_FAILED = 0xC0000BE0
      PDH_SQL_ALLOCCON_FAILED = 0xC0000BE1
      PDH_SQL_EXEC_DIRECT_FAILED = 0xC0000BE2
      PDH_SQL_FETCH_FAILED = 0xC0000BE3
      PDH_SQL_ROWCOUNT_FAILED = 0xC0000BE4
      PDH_SQL_MORE_RESULTS_FAILED = 0xC0000BE5
      PDH_SQL_CONNECT_FAILED = 0xC0000BE6
      PDH_SQL_BIND_FAILED = 0xC0000BE7
      PDH_CANNOT_CONNECT_WMI_SERVER = 0xC0000BE8
      PDH_PLA_COLLECTION_ALREADY_RUNNING = 0xC0000BE9
      PDH_PLA_ERROR_SCHEDULE_OVERLAP = 0xC0000BEA
      PDH_PLA_COLLECTION_NOT_FOUND = 0xC0000BEB
      PDH_PLA_ERROR_SCHEDULE_ELAPSED = 0xC0000BEC
      PDH_PLA_ERROR_NOSTART = 0xC0000BED
      PDH_PLA_ERROR_ALREADY_EXISTS = 0xC0000BEE
      PDH_PLA_ERROR_TYPE_MISMATCH = 0xC0000BEF
      PDH_PLA_ERROR_FILEPATH = 0xC0000BF0
      PDH_PLA_SERVICE_ERROR = 0xC0000BF1
      PDH_PLA_VALIDATION_ERROR = 0xC0000BF2
      PDH_PLA_VALIDATION_WARNING = 0x80000BF3
      PDH_PLA_ERROR_NAME_TOO_LONG = 0xC0000BF4
      PDH_INVALID_SQL_LOG_FORMAT = 0xC0000BF5
      PDH_COUNTER_ALREADY_IN_QUERY = 0xC0000BF6
      PDH_BINARY_LOG_CORRUPT = 0xC0000BF7
      PDH_LOG_SAMPLE_TOO_SMALL = 0xC0000BF8
      PDH_OS_LATER_VERSION = 0xC0000BF9
      PDH_OS_EARLIER_VERSION = 0xC0000BFA
      PDH_INCORRECT_APPEND_TIME = 0xC0000BFB
      PDH_UNMATCHED_APPEND_COUNTER = 0xC0000BFC
      PDH_SQL_ALTER_DETAIL_FAILED = 0xC0000BFD
      PDH_QUERY_PERF_DATA_TIMEOUT = 0xC0000BFE
      PERF_DETAIL_NOVICE = 100
      PERF_DETAIL_ADVANCED = 200
      PERF_DETAIL_EXPERT = 300
      PERF_DETAIL_WIZARD = 400
      ERROR_SUCCESS = 0x00000000

      # Value-to-name map, for reverse lookup.
      NAMES = {
        0x00000000 => 'PDH_CSTATUS_VALID_DATA'.freeze,
        0x00000001 => 'PDH_CSTATUS_NEW_DATA'.freeze,
        0x800007D0 => 'PDH_CSTATUS_NO_MACHINE'.freeze,
        0x800007D1 => 'PDH_CSTATUS_NO_INSTANCE'.freeze,
        0x800007D2 => 'PDH_MORE_DATA'.freeze,
        0x800007D3 => 'PDH_CSTATUS_ITEM_NOT_VALIDATED'.freeze,
        0x800007D4 => 'PDH_RETRY'.freeze,
        0x800007D5 => 'PDH_NO_DATA'.freeze,
        0x800007D6 => 'PDH_CALC_NEGATIVE_DENOMINATOR'.freeze,
        0x800007D7 => 'PDH_CALC_NEGATIVE_TIMEBASE'.freeze,
        0x800007D8 => 'PDH_CALC_NEGATIVE_VALUE'.freeze,
        0x800007D9 => 'PDH_DIALOG_CANCELLED'.freeze,
        0x800007DA => 'PDH_END_OF_LOG_FILE'.freeze,
        0x800007DB => 'PDH_ASYNC_QUERY_TIMEOUT'.freeze,
        0x800007DC => 'PDH_CANNOT_SET_DEFAULT_REALTIME_DATASOURCE'.freeze,
        0xC0000BB8 => 'PDH_CSTATUS_NO_OBJECT'.freeze,
        0xC0000BB9 => 'PDH_CSTATUS_NO_COUNTER'.freeze,
        0xC0000BBA => 'PDH_CSTATUS_INVALID_DATA'.freeze,
        0xC0000BBB => 'PDH_MEMORY_ALLOCATION_FAILURE'.freeze,
        0xC0000BBC => 'PDH_INVALID_HANDLE'.freeze,
        0xC0000BBD => 'PDH_INVALID_ARGUMENT'.freeze,
        0xC0000BBE => 'PDH_FUNCTION_NOT_FOUND'.freeze,
        0xC0000BBF => 'PDH_CSTATUS_NO_COUNTERNAME'.freeze,
        0xC0000BC0 => 'PDH_CSTATUS_BAD_COUNTERNAME'.freeze,
        0xC0000BC1 => 'PDH_INVALID_BUFFER'.freeze,
        0xC0000BC2 => 'PDH_INSUFFICIENT_BUFFER'.freeze,
        0xC0000BC3 => 'PDH_CANNOT_CONNECT_MACHINE'.freeze,
        0xC0000BC4 => 'PDH_INVALID_PATH'.freeze,
        0xC0000BC5 => 'PDH_INVALID_INSTANCE'.freeze,
        0xC0000BC6 => 'PDH_INVALID_DATA'.freeze,
        0xC0000BC7 => 'PDH_NO_DIALOG_DATA'.freeze,
        0xC0000BC8 => 'PDH_CANNOT_READ_NAME_STRINGS'.freeze,
        0xC0000BC9 => 'PDH_LOG_FILE_CREATE_ERROR'.freeze,
        0xC0000BCA => 'PDH_LOG_FILE_OPEN_ERROR'.freeze,
        0xC0000BCB => 'PDH_LOG_TYPE_NOT_FOUND'.freeze,
        0xC0000BCC => 'PDH_NO_MORE_DATA'.freeze,
        0xC0000BCD => 'PDH_ENTRY_NOT_IN_LOG_FILE'.freeze,
        0xC0000BCE => 'PDH_DATA_SOURCE_IS_LOG_FILE'.freeze,
        0xC0000BCF => 'PDH_DATA_SOURCE_IS_REAL_TIME'.freeze,
        0xC0000BD0 => 'PDH_UNABLE_READ_LOG_HEADER'.freeze,
        0xC0000BD1 => 'PDH_FILE_NOT_FOUND'.freeze,
        0xC0000BD2 => 'PDH_FILE_ALREADY_EXISTS'.freeze,
        0xC0000BD3 => 'PDH_NOT_IMPLEMENTED'.freeze,
        0xC0000BD4 => 'PDH_STRING_NOT_FOUND'.freeze,
        0x80000BD5 => 'PDH_UNABLE_MAP_NAME_FILES'.freeze,
        0xC0000BD6 => 'PDH_UNKNOWN_LOG_FORMAT'.freeze,
        0xC0000BD7 => 'PDH_UNKNOWN_LOGSVC_COMMAND'.freeze,
        0xC0000BD8 => 'PDH_LOGSVC_QUERY_NOT_FOUND'.freeze,
        0xC0000BD9 => 'PDH_LOGSVC_NOT_OPENED'.freeze,
        0xC0000BDA => 'PDH_WBEM_ERROR'.freeze,
        0xC0000BDB => 'PDH_ACCESS_DENIED'.freeze,
        0xC0000BDC => 'PDH_LOG_FILE_TOO_SMALL'.freeze,
        0xC0000BDD => 'PDH_INVALID_DATASOURCE'.freeze,
        0xC0000BDE => 'PDH_INVALID_SQLDB'.freeze,
        0xC0000BDF => 'PDH_NO_COUNTERS'.freeze,
        0xC0000BE0 => 'PDH_SQL_ALLOC_FAILED'.freeze,
        0xC0000BE1 => 'PDH_SQL_ALLOCCON_FAILED'.freeze,
        0xC0000BE2 => 'PDH_SQL_EXEC_DIRECT_FAILED'.freeze,
        0xC0000BE3 => 'PDH_SQL_FETCH_FAILED'.freeze,
        0xC0000BE4 => 'PDH_SQL_ROWCOUNT_FAILED'.freeze,
        0xC0000BE5 => 'PDH_SQL_MORE_RESULTS_FAILED'.freeze,
        0xC0000BE6 => 'PDH_SQL_CONNECT_FAILED'.freeze,
        0xC0000BE7 => 'PDH_SQL_BIND_FAILED'.freeze,
        0xC0000BE8 => 'PDH_CANNOT_CONNECT_WMI_SERVER'.freeze,
        0xC0000BE9 => 'PDH_PLA_COLLECTION_ALREADY_RUNNING'.freeze,
        0xC0000BEA => 'PDH_PLA_ERROR_SCHEDULE_OVERLAP'.freeze,
        0xC0000BEB => 'PDH_PLA_COLLECTION_NOT_FOUND'.freeze,
        0xC0000BEC => 'PDH_PLA_ERROR_SCHEDULE_ELAPSED'.freeze,
        0xC0000BED => 'PDH_PLA_ERROR_NOSTART'.freeze,
        0xC0000BEE => 'PDH_PLA_ERROR_ALREADY_EXISTS'.freeze,
        0xC0000BEF => 'PDH_PLA_ERROR_TYPE_MISMATCH'.freeze,
        0xC0000BF0 => 'PDH_PLA_ERROR_FILEPATH'.freeze,
        0xC0000BF1 => 'PDH_PLA_SERVICE_ERROR'.freeze,
        0xC0000BF2 => 'PDH_PLA_VALIDATION_ERROR'.freeze,
        0x80000BF3 => 'PDH_PLA_VALIDATION_WARNING'.freeze,
        0xC0000BF4 => 'PDH_PLA_ERROR_NAME_TOO_LONG'.freeze,
        0xC0000BF5 => 'PDH_INVALID_SQL_LOG_FORMAT'.freeze,
        0xC0000BF6 => 'PDH_COUNTER_ALREADY_IN_QUERY'.freeze,
        0xC0000BF7 => 'PDH_BINARY_LOG_CORRUPT'.freeze,
        0xC0000BF8 => 'PDH_LOG_SAMPLE_TOO_SMALL'.freeze,
        0xC0000BF9 => 'PDH_OS_LATER_VERSION'.freeze,
        0xC0000BFA => 'PDH_OS_EARLIER_VERSION'.freeze,
        0xC0000BFB => 'PDH_INCORRECT_APPEND_TIME'.freeze,
        0xC0000BFC => 'PDH_UNMATCHED_APPEND_COUNTER'.freeze,
        0xC0000BFD => 'PDH_SQL_ALTER_DETAIL_FAILED'.freeze,
        0xC0000BFE => 'PDH_QUERY_PERF_DATA_TIMEOUT'.freeze,
      }.freeze

      # Value-to-message hash, for generating messages.
      MESSAGES = {
        0x00000000 => 'The returned data is valid.'.freeze,
        0x00000001 => 'The return data value is valid and different from the last sample.'.freeze,
        0x800007D0 => 'Unable to connect to the specified computer, or the computer is offline.'.freeze,
        0x800007D1 => 'The specified instance is not present.'.freeze,
        0x800007D2 => 'There is more data to return than would fit in the supplied buffer. Allocate a larger buffer and call the function again.'.freeze,
        0x800007D3 => 'The data item has been added to the query but has not been validated nor accessed. No other status information on this data item is available.'.freeze,
        0x800007D4 => 'The selected operation should be retried.'.freeze,
        0x800007D5 => 'No data to return.'.freeze,
        0x800007D6 => 'A counter with a negative denominator value was detected.'.freeze,
        0x800007D7 => 'A counter with a negative time base value was detected.'.freeze,
        0x800007D8 => 'A counter with a negative value was detected.'.freeze,
        0x800007D9 => 'The user canceled the dialog box.'.freeze,
        0x800007DA => 'The end of the log file was reached.'.freeze,
        0x800007DB => 'A time-out occurred while waiting for the asynchronous counter collection thread to end.'.freeze,
        0x800007DC => 'Cannot change set default real-time data source. There are real-time query sessions collecting counter data.'.freeze,
        0xC0000BB8 => 'The specified object is not found on the system.'.freeze,
        0xC0000BB9 => 'The specified counter could not be found.'.freeze,
        0xC0000BBA => 'The returned data is not valid.'.freeze,
        0xC0000BBB => 'A PDH function could not allocate enough temporary memory to complete the operation. Close some applications or extend the page file and retry the function.'.freeze,
        0xC0000BBC => 'The handle is not a valid PDH object.'.freeze,
        0xC0000BBD => 'A required argument is missing or incorrect.'.freeze,
        0xC0000BBE => 'Unable to find the specified function.'.freeze,
        0xC0000BBF => 'No counter was specified.'.freeze,
        0xC0000BC0 => 'Unable to parse the counter path. Check the format and syntax of the specified path.'.freeze,
        0xC0000BC1 => 'The buffer passed by the caller is not valid.'.freeze,
        0xC0000BC2 => 'The requested data is larger than the buffer supplied. Unable to return the requested data.'.freeze,
        0xC0000BC3 => 'Unable to connect to the requested computer.'.freeze,
        0xC0000BC4 => 'The specified counter path could not be interpreted.'.freeze,
        0xC0000BC5 => 'The instance name could not be read from the specified counter path.'.freeze,
        0xC0000BC6 => 'The data is not valid.'.freeze,
        0xC0000BC7 => 'The dialog box data block was missing or not valid.'.freeze,
        0xC0000BC8 => 'Unable to read the counter and/or help text from the specified computer.'.freeze,
        0xC0000BC9 => 'Unable to create the specified log file.'.freeze,
        0xC0000BCA => 'Unable to open the specified log file.'.freeze,
        0xC0000BCB => 'The specified log file type has not been installed on this system.'.freeze,
        0xC0000BCC => 'No more data is available.'.freeze,
        0xC0000BCD => 'The specified record was not found in the log file.'.freeze,
        0xC0000BCE => 'The specified data source is a log file.'.freeze,
        0xC0000BCF => 'The specified data source is the current activity.'.freeze,
        0xC0000BD0 => 'The log file header could not be read.'.freeze,
        0xC0000BD1 => 'Unable to find the specified file.'.freeze,
        0xC0000BD2 => 'There is already a file with the specified file name.'.freeze,
        0xC0000BD3 => 'The function referenced has not been implemented.'.freeze,
        0xC0000BD4 => 'Unable to find the specified string in the list of performance name and help text strings.'.freeze,
        0x80000BD5 => 'Unable to map to the performance counter name data files. The data will be read from the registry and stored locally.'.freeze,
        0xC0000BD6 => 'The format of the specified log file is not recognized by the PDH DLL.'.freeze,
        0xC0000BD7 => 'The specified Log Service command value is not recognized.'.freeze,
        0xC0000BD8 => 'The specified query from the Log Service could not be found or could not be opened.'.freeze,
        0xC0000BD9 => 'The Performance Data Log Service key could not be opened. This may be due to insufficient privilege or because the service has not been installed.'.freeze,
        0xC0000BDA => 'An error occurred while accessing the WBEM data store.'.freeze,
        0xC0000BDB => 'Unable to access the desired computer or service. Check the permissions and authentication of the log service or the interactive user session against those on the computer or service being monitored.'.freeze,
        0xC0000BDC => 'The maximum log file size specified is too small to log the selected counters. No data will be recorded in this log file. Specify a smaller set of counters to log or a larger file size and retry this call.'.freeze,
        0xC0000BDD => 'Cannot connect to ODBC DataSource Name.'.freeze,
        0xC0000BDE => 'SQL Database does not contain a valid set of tables for Perfmon.'.freeze,
        0xC0000BDF => 'No counters were found for this Perfmon SQL Log Set.'.freeze,
        0xC0000BE0 => 'Call to SQLAllocStmt failed with %1.'.freeze,
        0xC0000BE1 => 'Call to SQLAllocConnect failed with %1.'.freeze,
        0xC0000BE2 => 'Call to SQLExecDirect failed with %1.'.freeze,
        0xC0000BE3 => 'Call to SQLFetch failed with %1.'.freeze,
        0xC0000BE4 => 'Call to SQLRowCount failed with %1.'.freeze,
        0xC0000BE5 => 'Call to SQLMoreResults failed with %1.'.freeze,
        0xC0000BE6 => 'Call to SQLConnect failed with %1.'.freeze,
        0xC0000BE7 => 'Call to SQLBindCol failed with %1.'.freeze,
        0xC0000BE8 => 'Unable to connect to the WMI server on requested computer.'.freeze,
        0xC0000BE9 => 'Collection "%1!s!" is already running.'.freeze,
        0xC0000BEA => 'The specified start time is after the end time.'.freeze,
        0xC0000BEB => 'Collection "%1!s!" does not exist.'.freeze,
        0xC0000BEC => 'The specified end time has already elapsed.'.freeze,
        0xC0000BED => 'Collection "%1!s!" did not start; check the application event log for any errors.'.freeze,
        0xC0000BEE => 'Collection "%1!s!" already exists.'.freeze,
        0xC0000BEF => 'There is a mismatch in the settings type.'.freeze,
        0xC0000BF0 => 'The information specified does not resolve to a valid path name.'.freeze,
        0xC0000BF1 => 'The "Performance Logs & Alerts" service did not respond.'.freeze,
        0xC0000BF2 => 'The information passed is not valid.'.freeze,
        0x80000BF3 => 'The information passed is not valid.'.freeze,
        0xC0000BF4 => 'The name supplied is too long.'.freeze,
        0xC0000BF5 => 'SQL log format is incorrect. Correct format is "SQL:<DSN-name>!<LogSet-Name>".'.freeze,
        0xC0000BF6 => 'Performance counter in PdhAddCounter call has already been added in the performance query. This counter is ignored.'.freeze,
        0xC0000BF7 => 'Unable to read counter information and data from input binary log files.'.freeze,
        0xC0000BF8 => 'At least one of the input binary log files contain fewer than two data samples.'.freeze,
        0xC0000BF9 => 'The version of the operating system on the computer named %1 is later than that on the local computer. This operation is not available from the local computer.'.freeze,
        0xC0000BFA => '%1 supports %2 or later. Check the operating system version on the computer named %3.'.freeze,
        0xC0000BFB => 'The output file must contain earlier data than the file to be appended.'.freeze,
        0xC0000BFC => 'Both files must have identical counters in order to append.'.freeze,
        0xC0000BFD => 'Cannot alter CounterDetail table layout in SQL database.'.freeze,
        0xC0000BFE => 'System is busy. A time-out occurred when collecting counter data. Please retry later or increase the CollectTime registry value.'.freeze,
      }.freeze
    end
  end
end
